Ruby - Feature #14683

IRB with Ripper
04/12/2018 03:06 PM - aycabta (aycabta .)

Status: Closed

Priority: Normal

Assignee: keiju (Keiju Ishitsuka)
Target version:

Description
| replaced lexical analyzer with Ripper. It's important for supporting new syntax.

| explain what | did.
Replace with Ripper
| talked with @matz (Yukihiro Matsumoto) about it and | decided to use mirb of mruby as a reference.

https://github.com/mruby/mruby/blob/1905091634a6a2925¢911484434448e568330626/mrbgems/mruby-bin-mirb/tools/mirb/mirb.c#L
118-L.217

The mirb uses compile error messages and token information such as token type and lex_state for that whether or not inputted code
continues(and PROMPT_N). | used RubyVM::InstructionSequence#compile and Ripper for the same action.

ref. IRB#each_top_level_statement, IRB#lex and IRB#check_code_block

Continue(PROMPT _N), literal type(PROMPT_S), nesting level(%NNi)

IRB needs statuses of code snippets. @nobu (Nobuyoshi Nakada) implemented it as Ripper's features at irb-ripper branch on
GitHub.
https://github.com/nobu/ruby/commits/feature/irb-ripper

| implemented by pure Ruby because | heard what @nobu (Nobuyoshi Nakada) thinks pure Ruby implementation for it. | think that
it's the best way for that Ripper keeps simple.

ref. IRB#process_continue, IRB#process_nesting_level, IRB#check_string_literal and IRB#process_literal_type
Erase --irb_debug option

Because this is just for pure Ruby lexical analyzer.

History

#1 - 04/12/2018 04:50 PM - aycabta (aycabta .)
ref. https://github.com/ruby/rdoc/pull/512

#2 - 04/13/2018 12:49 AM - hsbt (Hiroshi SHIBATA)
- Status changed from Open to Assigned

- Assignee set to keiju (Keiju Ishitsuka)

#3 - 04/19/2018 04:17 PM - keiju (Keiju Ishitsuka)

| am developing Reirb which is new version of irb, now.
Reirb is a reborn irb, and new implementation for irb,
| would like to replacing irb with reirb(as irb).

Therefore, | want to pending big changes until RubyKaigi 2018 is over.

#4 - 05/05/2018 10:53 AM - aycabta (aycabta .)
| discussed this issue with @hsbt (Hiroshi SHIBATA), @matsuda (Akira Matsuda), and @matz (Yukihiro Matsumoto) .

In the present day, IRB needs compatibility completely.
e Bundler generates template files of new RubyGems with example console as "bin/console" for development. It uses IRB. Developers of gems
can edit the file because it's just template file of customized IRB console.

¢ All Ruby on Rails applications have "rails console" command.

e Many users customize .irbrc deeply includes me.

Ruby needs a simple REPL as IRB with perfect compatibility. And @matz (Yukihiro Matsumoto) said that IRB should not be replaced without
compatibility in the discussion with me. IRB is still contributing greatly to Ruby's system and we must continue to maintain IRB's compatibility in the
future. | think that you'd better develop new Ruby REPL(or shell) without the weighty responsibility of heavy compatibility.

If you can provide perfect compatibility for the new version of IRB, please publish the source code of it because | want to contribute. If not, please
discuss this issue without the new version of IRB.

At RubyKaigi 2018, I'll talk about IRB's new features.
http://rubykaigi.org/2018/presentations/aycabta.html
So | need a source code of IRB that | can contribute.

@keiju (Keiju Ishitsuka) san, | watched all your presentations of Ruby shell in RubyKaigi 2014, 2015, and 2017. I'm looking forward to living on your
Ruby shell.

#5 - 05/28/2019 12:06 AM - aycabta (aycabta .)

- Status changed from Assigned to Closed

Files

irb.patch 51.8 KB 04/12/2018 aycabta (aycabta .)
